-- Copyright © 2012 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.
-- Current distribution permissions only include curse.com, wowui.worldofwar.net, wowinterface.com and their respective addon updaters

local _, MonkTimers = ...

local SpellIDs = MonkTimers.SpellIDs
local SpellTextures = MonkTimers.SpellTextures
local SpellNames = MonkTimers.SpellNames
local AvailableSpells = MonkTimers.AvailableSpells

local cds = {}
--local spells = {SpellNames[SpellIDs.StormStrike], SpellNames[SpellIDs.EarthShock], SpellNames[SpellIDs.LavaLash], SpellNames[SpellIDs.FlameShock]}
local playerName = UnitName("player")
local role = 1

local num_CD_Spells = {[1]=2,[2]=1,[3]=1,}
MonkTimers.num_CD_Spells = num_CD_Spells

local function NoUpdate()
end


local CD_Spells = {
    [1] = {
        [1] = SpellIDs.TigerPalm,
        [2] = SpellIDs.BlackoutKick,
    },
    [2] = {
        [1] = SpellIDs.TigerPalm,

    },
    [3] = {
        [1] = SpellIDs.TigerPalm,
    },
}

MonkTimers.CD_Spells = CD_Spells

local function ActivateCD(self)
    XiTimers.Activate(self)
end

   
local function ChangeTimerOrder(self,spell)
    if InCombatLockdown() then return end
    if not spell then return end
    local _,spell1 = GetSpellBookItemInfo(spell, "BOOKTYPE_SPELL")
    local spell2 = self:GetAttribute("orderspell")    
    if not spell2 or not spell1 then return end
    local spellnum1, spellnum2 = nil,nil
    for i=1,num_CD_Spells[role] do
        if CD_Spells[role][i] == spell1 then spellnum1 = i end
        if CD_Spells[role][i] == spell2 then spellnum2 = i end        
    end
    if not spellnum1 or not spellnum2 then return end
    local order1, order2 = nil
    for i=1,#MonkTimers.ActiveProfile.Timer_Order[role] do
        if MonkTimers.ActiveProfile.Timer_Order[role][i] == spellnum1 then order1 = i end
        if MonkTimers.ActiveProfile.Timer_Order[role][i] == spellnum2 then order2 = i end
    end
    if not order1 or not order2 then return end
    MonkTimers.ActiveProfile.Timer_Order[role][order1], MonkTimers.ActiveProfile.Timer_Order[role][order2] =
        MonkTimers.ActiveProfile.Timer_Order[role][order2], MonkTimers.ActiveProfile.Timer_Order[role][order1]
    MonkTimers.LayoutTimers()
end
   
function MonkTimers.CreateTimers()
    for i = 1,10 do
        cds[i] = XiTimers:new(1)
        cds[i].events[1] = "SPELL_UPDATE_COOLDOWN"
        cds[i].dontFlash = true
        cds[i].timeStyle = "sec"
        cds[i].button.anchorframe = MonkTimersFrame
        cds[i].button:SetAttribute("*type*", "spell")
        --cds[i].activate = ActivateCD
        cds[i].reverseAlpha = true
        --cds[i].dontAlpha = true
        cds[i].button.icons[1]:SetAlpha(1)
        cds[i].button:SetScript("OnEvent", MonkTimers.TimerEvents)
        cds[i].button:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp")
    end
    --[[cds[8].prohibitCooldown = true
    cds[8].reverseAlpha = nil
    cds[12] = XiTimers:new(1, true)
    cds[12].button:Disable()
    cds[12].button.icons[1]:SetVertexColor(1,1,1)
    cds[13] = XiTimers:new(1,true)
    cds[13].button:Disable()
    cds[13].button.icons[1]:SetVertexColor(1,1,1)
    cds[13].hideInactive = true
    cds[13].timeStyle = "sec"
    cds[13].button:SetScript("OnEvent", MonkTimers.FeralSpiritEvent) 
    cds[13].button.cdspell = SpellIDs.FeralSpirit
    cds[13].button.icons[1]:SetTexture(SpellTextures[SpellIDs.FeralSpirit])
    cds[13].events[1] = "UNIT_SPELLCAST_SUCCEEDED"
    --cds[1].button.BorderBar:SetStatusBarColor(0.9,0.2,0.2,1)
    --cds[2].button.BorderBar:SetStatusBarColor(0.9,0.2,0.2,1)]]
    --!!

    for i=1,10 do
        cds[i].button:SetAttribute("_ondragstart",[[if IsShiftKeyDown() and self:GetAttribute("orderspell")~=0 then
                                                    return "spell", self:GetAttribute("orderspell")
                                              else control:CallMethod("StartMove") end]])
        cds[i].button:SetAttribute("_onreceivedrag",[[ if kind == "spell" then
                                                   control:CallMethod("ChangeTimerOrder", value, ...)
                                                    return "clear"
                                              end]])
        cds[i].button.ChangeCDOrder = ChangeCDOrder
    end
end

function MonkTimers.ConfigTimers() 
    role = GetSpecialization()
    if not role then role = 2 end
   
    
    for i=1,10 do
        cds[i]:Deactivate()
    end
    
    if not MonkTimers.ActiveProfile.Timers then return end

    for i=1,num_CD_Spells[role] do
        cds[i].button.cdspell = CD_Spells[role][i]
        cds[i].button.icons[1]:SetTexture(SpellTextures[CD_Spells[role][i]])
        cds[i].button:SetAttribute("*spell1", SpellNames[CD_Spells[role][i]])
        cds[i].RangeCheck = SpellNames[CD_Spells[role][i]]
        cds[i].ManaCheck = SpellNames[CD_Spells[role][i]]
        cds[i].button:SetScript("OnEvent", MonkTimers.TimerEvents)
        cds[i].Update = nil
        cds[i].prohibitCooldown = false
        cds[i].button:SetAttribute("orderspell", CD_Spells[role][i])
        cds[i].events = {"SPELL_UPDATE_COOLDOWN"}
        cds[i].barTimerOnly = false
        cds[i].reverseAlpha = false
    end
    
    cds[1].prohibitCooldown = true
    cds[1].button:SetScript("OnEvent", MonkTimers.TigerPalmEvent)
    cds[1].events[1] = "UNIT_AURA"
    cds[1].barTimerOnly = true
    cds[1].reverseAlpha = true
    cds[1].button.bar:SetStatusBarColor(0.6,0.6,1,0.7)
    cds[2].events[1] = "UNIT_AURA"
    cds[2].button:SetScript("OnEvent", MonkTimers.BlackoutKickEvent)
    cds[2].reverseAlpha = true
    
    for i=1,num_CD_Spells[role] do
        if MonkTimers.ActiveProfile.Timer_Spells[role][i] and AvailableSpells[CD_Spells[role][MonkTimers.ActiveProfile.Timer_Order[role][i]]] then
            cds[i]:Activate()
        end
    end
end

local active_cds = {}

local function ConvertCoords(frame1, frame2)
    return frame1:GetEffectiveScale()/frame2:GetEffectiveScale()
end


function MonkTimers.LayoutTimers()
    wipe(active_cds)
    for i=1,num_CD_Spells[role] do
        if cds[MonkTimers.ActiveProfile.Timer_Order[role][i]].active then
            table.insert(active_cds,cds[MonkTimers.ActiveProfile.Timer_Order[role][i]])
        end
    end
    for i=1,1 do 
        cds[i]:ClearAnchors()
        cds[i].button:ClearAllPoints()
    end
    local xmove, xmovebottom = 0, 0
    local fsreltop = nil
    local fsrelbottom = nil
    if #active_cds == 0 then
       --[[ if cds[9].active then
            cds[9].button:SetPoint("TOPRIGHT", MonkTimersFrame)
        else
            cds[9].button:SetPoint("BOTTOMRIGHT", MonkTimersFrame)
        end
        if cds[10].active then
            cds[10].button:SetPoint("BOTTOM", MonkTimersFrame)
        end]]
    elseif #active_cds == 1 then
        active_cds[1].button:SetPoint("CENTER", MonkTimersFrame)
        fsreltop = active_cds[1].button
        fsrelbottom = active_cds[1].button
        xmovetop = -(MonkTimers.ActiveProfile.TimerSize*3.5+5)
        xmovebottom = -(MonkTimers.ActiveProfile.TimerSize*3.5+5)
    elseif #active_cds == 2 then
        active_cds[1].button:SetPoint("RIGHT", MonkTimers_EnhanceCDsFrame, "CENTER", -3, 0)
        active_cds[2]:Anchor(active_cds[1], "LEFT")
        fsreltop = active_cds[1].button
        fsrelbottom = active_cds[1].button
        xmovetop = -(MonkTimers.ActiveProfile.TimerSize*2.5+5)
        xmovebottom = -(MonkTimers.ActiveProfile.TimerSize*2.5+5)
    elseif #active_cds == 3 then
        active_cds[2].button:SetPoint("CENTER", MonkTimers_EnhanceCDsFrame)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        fsreltop = active_cds[1].button
        fsrelbottom = active_cds[1].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 4 then 
        active_cds[2].button:SetPoint("RIGHT", MonkTimers_EnhanceCDsFrame, -3, 0)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        xmovebottom = (MonkTimers.ActiveProfile.TimerSize*0.5+5)
        xmovetop = 0
        fsreltop = cds[1].button
        fsrelbottom = cds[1].button
    elseif #active_cds == 5 then
        active_cds[1].button:SetPoint("RIGHT", MonkTimers_EnhanceCDsFrame, "CENTER", -3, 0)
        active_cds[2]:Anchor(active_cds[1], "LEFT")
        active_cds[3]:Anchor(active_cds[1], "TOPRIGHT", "BOTTOM", true)
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[5]:Anchor(active_cds[4], "LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 6 then
        active_cds[2].button:SetPoint("CENTER", MonkTimers_EnhanceCDsFrame)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[5]:Anchor(active_cds[2], "TOP", "BOTTOM")
        active_cds[4]:Anchor(active_cds[5],"RIGHT")
        active_cds[6]:Anchor(active_cds[5],"LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 7 then
        active_cds[2].button:SetPoint("CENTER", MonkTimers_EnhanceCDsFrame)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[5]:Anchor(active_cds[2], "TOPRIGHT", "BOTTOM", true)
        active_cds[4]:Anchor(active_cds[5], "RIGHT")
        active_cds[6]:Anchor(active_cds[5], "LEFT")
        active_cds[7]:Anchor(active_cds[6], "LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 8 then
        active_cds[2].button:SetPoint("RIGHT", MonkTimers_EnhanceCDsFrame, -3, 0)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[5]:Anchor(active_cds[1], "TOP", "BOTTOM")
        active_cds[6]:Anchor(active_cds[2], "TOP", "BOTTOM")
        active_cds[7]:Anchor(active_cds[3], "TOP", "BOTTOM")
        active_cds[8]:Anchor(active_cds[4], "TOP", "BOTTOM")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 9 then
        active_cds[2].button:SetPoint("RIGHT", MonkTimers_EnhanceCDsFrame, -3, 0)
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[3]:Anchor(active_cds[2], "LEFT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[6]:Anchor(active_cds[2], "TOPRIGHT", "BOTTOM", true)
        active_cds[5]:Anchor(active_cds[6], "RIGHT")
        active_cds[7]:Anchor(active_cds[6], "LEFT")
        active_cds[8]:Anchor(active_cds[7], "LEFT")
        active_cds[9]:Anchor(active_cds[8], "LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 10 then
        active_cds[3].button:SetPoint("CENTER", MonkTimers_EnhanceCDsFrame)
        active_cds[2]:Anchor(active_cds[3], "RIGHT")
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[5]:Anchor(active_cds[4], "LEFT")
        active_cds[6]:Anchor(active_cds[1], "TOP", "BOTTOM")
        active_cds[7]:Anchor(active_cds[2], "TOP", "BOTTOM")
        active_cds[8]:Anchor(active_cds[3], "TOP", "BOTTOM")
        active_cds[9]:Anchor(active_cds[4], "TOP", "BOTTOM")
        active_cds[10]:Anchor(active_cds[5], "TOP", "BOTTOM")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0
    elseif #active_cds == 11 then
        active_cds[3].button:SetPoint("CENTER", MonkTimers_EnhanceCDsFrame)
        active_cds[2]:Anchor(active_cds[3], "RIGHT")
        active_cds[1]:Anchor(active_cds[2], "RIGHT")
        active_cds[4]:Anchor(active_cds[3], "LEFT")
        active_cds[5]:Anchor(active_cds[4], "LEFT")
        active_cds[6]:Anchor(active_cds[1], "TOPRIGHT", "BOTTOM", true)
        active_cds[7]:Anchor(active_cds[6], "LEFT")
        active_cds[8]:Anchor(active_cds[7], "LEFT")
        active_cds[9]:Anchor(active_cds[8], "LEFT")
        active_cds[10]:Anchor(active_cds[9], "LEFT")
        active_cds[11]:Anchor(active_cds[10], "LEFT")
        fsreltop = cds[1].button
        fsrelbottom = cds[3].button
        xmovebottom = 0
        xmovetop = 0 
    end
end

function MonkTimers.ActivateTimers()
    MonkTimers.ConfigTimers()
    MonkTimers.LayoutTimers()
end

function MonkTimers.DeactivateTimers()
    for k,v in pairs(cds) do
        v:Deactivate()
    end
end

function MonkTimers.TimerEvents(self, event, ...)
    local settings = MonkTimers.ActiveProfile
    if event == "SPELL_UPDATE_COOLDOWN" and AvailableSpells[self.cdspell] then 
        local start, duration, enable = GetSpellCooldown(self.cdspell)
        if (not start and not duration) or (duration <= 1.5 and not InCombatLockdown()) then
            self.timer:Stop(1)					
        else
            if duration == 0 then
                self.timer:Stop(1)
            elseif duration > 2 and self.timer.timers[1]<=0 then
                self.timer:Start(1,start+duration-floor(GetTime()),duration)
            end
            CooldownFrame_SetTimer(self.cooldown, start, duration, enable)
        end 
    end
end



local TigerPower = SpellNames[SpellIDs.TigerPower]

function MonkTimers.TigerPalmEvent(self, event, ...)
    if event == "UNIT_AURA" then
        local unit = ...
        if unit == "player" then
            local _,_,_,count,_,duration, expiration = UnitBuff("player", TigerPower)
            if count and count > 0 then
                self.timer:Start(1, count)
                self.timer:StartBarTimer(expiration-GetTime(), duration)
            elseif self.timer.timers[1]>0 then
                self.timer:Stop(1)
            end
        end
    end
end


local Shuffle = SpellNames[SpellIDs.Shuffle]

function MonkTimers.BlackoutKickEvent(self, event, ...)
    if event == "UNIT_AURA" then
        local unit = ...
        if unit == "player" then
            local _,_,_,count,_,duration, expiration = UnitBuff("player", Shuffle) print(count)
            if duration and duration > 0 then
                self.timer:Start(1, expiration-GetTime(), duration)
            elseif self.timer.timers[1]>0 then
                self.timer:Stop(1)
            end
        end
     end
end





function MonkTimers.ElementalMasteryUpdate(self,elapsed)
    XiTimers.Update(self,elapsed)
    if self.timers[1] > 0 then
        local start, duration, enable = GetSpellCooldown(self.button.cdspell)
        if (not start and not duration) then
            self:Stop(1)					
        else
            if duration == 0 then
                self:Stop(1)
            elseif (start+duration-floor(GetTime())) < self.timers[1]-1 then
                self.timers[1] = start+duration-floor(GetTime())
            end
        end
    end        
end


function MonkTimers.ShieldChargeEvent(self, event, ...)
	if event == "UNIT_AURA" and select(1,...) =="player" then
		local name,_,texture,count,_,duration,endtime = UnitAura("player", ShieldName)

		if name then
			self.timer:Start(1, count, 9)
		elseif self.timer.timers[1]>0 then
			self.timer:Stop(1)
		end
	elseif event ~= "SPELL_UPDATE_COOLDOWN" then
        MonkTimers.EnhanceCDEvents(self,event,...)
    end
end



local AuraGUID = nil
local FSEv, FSSource, FSTarget, FSSpell, FSBuffType, FSDuration, FSExpires, FSID = nil

local function CheckFSBuff(self, unit)
    if --[[(unit == "target" or unit == "focus") and]] UnitGUID(unit) == AuraGUID then
        _,_,_,_,_,FSDuration,FSExpires,FSSource,_,_,FSID = UnitDebuff(unit, FlameShockName)
        if FSID == FlameShockID and FSDuration and FSSource == "player" then 
            self.timer:Start(1, -1 * GetTime() + FSExpires, FSDuration)
        elseif not FSID then
            self.timer:Stop(1)
        end
    end
end

function MonkTimers.FlameShockEvent(self,event,...)
    if event == "COMBAT_LOG_EVENT_UNFILTERED" then
        _, FSEv, _, _, FSSource, _, _, FSTarget, _, _, _, FSSpell = ...
        if FSEv == "SPELL_DAMAGE" then
            if FSSource == playerName and FSSpell == FlameShockID then 
                AuraGUID = FSTarget
                MonkTimers.FlameShockEvent(self, "UNIT_AURA", "target")
            end
        elseif FSEv == "UNIT_DIED" then
            if AuraGUID and FSTarget == AuraGUID then
                self.timer:Stop(1)
                AuraGUID = nil
            end
        end
    elseif event == "PLAYER_TARGET_CHANGED" and UnitExists("target") then
        AuraGUID = UnitGUID("target")
        CheckFSBuff(self, "target")
    elseif event == "UNIT_AURA" then
        local unit = ...
        CheckFSBuff(self, unit)
    end
end


